from wxPython.wx import *

from Thuban.Model.histogram import *

class Graph(wxPanel):

    def __init__(self, parent, width, height):
        wxPanel.__init__(self, parent, -1, wxPoint(-1,-1), wxSize(width,height))
        self.w = width
        self.h = height
        self.flipx = lambda x: x
        self.flipy = lambda y: 1.0-y
        self.border = 0.02
        EVT_PAINT(self, self.OnPaint)
        
    def scaleit(self,x,y):
        """ From cartesian (x,y) normalized to [0,1], calculate screen coordinates. """
        return (self.w*((1.0-2.0*self.border)*self.flipx(x)+self.border),
                self.h*((1.0-2.0*self.border)*(self.flipy(y))+self.border))
    
    def draw_rect(self, dc, ul, lr):
        ulx,uly = self.scaleit(ul[0],ul[1])
        lrx,lry = self.scaleit(lr[0],lr[1])
        dc.DrawLine( ulx,uly,lrx,uly )
        dc.DrawLine( lrx,uly,lrx,lry )
        dc.DrawLine( lrx,lry,ulx,lry )
        dc.DrawLine( ulx,lry,ulx,uly )
        
    def draw_line(self,dc,x1,y1,x2,y2):
        x1,y1 = self.scaleit(x1,y1)
        x2,y2 = self.scaleit(x2,y2)
        dc.DrawLine(x1,y1,x2,y2)
        
    def OnPaint(self, event):
        dc = wxPaintDC(self)
        #        dc.SetBackground(wxTRANSPARENT_BRUSH)
        dc.Clear()
        (self.w, self.h) = dc.GetSizeTuple()
        self.refresh(dc)
        
    def refresh(self,dc):
        pass

