from wxPython.wx import *

from Thuban.Model.histogram import *

from Thuban.UI.graph import *

class Histogram(Graph):

    def __init__(self, parent, data=None, bins=10, flipy=0):
        Graph.__init__(self, parent, 400, 200)
        self.data = data
        if type(bins) == type([]):
            self.bins = bins
            self.nbins = None
        else:
            self.nbins = bins
            self.bins = None
        if flipy:
            self.flipy = lambda x: x

    def draw_hist(self,dc, values, series, binsizes=None):
        mxs = max(series)
        y = [ float(v)/mxs for v in series ]
        
        mnv = float(min(values))
        mxv = float(max(values))
        if binsizes is None:
            x = [ (float(v)-mnv)/(mxv-mnv) for v in values ]
            x.sort()
            dx = filter( lambda x: x>0 , [ x[i+1]-x[i] for i in range(len(x)-1) ]  )
            binsizes = [ min(dx) ] * len(x)
#        print "binsizes:",binsizes
        x = [ float(values[i]-mnv)/(mxv-mnv) # values normalized to [0,1]
              for i in range(len(x)) ]
        mxx = max(x)
        binsizes = [ 0.99*b for b in binsizes ]
        dc.SetPen(wxPen(wxNamedColor("black"),1))
        self.draw_rect(dc, (0.0,0.0), (1.0,1.0) )
        dc.SetPen(wxPen(wxNamedColor("blue"),2))
        for i in range(len(y)):
            self.draw_rect(dc, \
                           (max(x[i]-0.5*binsizes[i],0),y[i]),
                           (min(x[i]+0.5*binsizes[i],mxx),0.0) )
            xb = x[i]
            self.draw_line(dc,xb,0.0,xb,.02 )
            
    def refresh(self,dc):
        self.draw_hist(dc)


class BinHistogram(Histogram):
    def refresh(self,dc):
        y = histcount(self.data, self.nbins)
        x = [ float(v)/self.nbins for v in range(self.nbins) ]
        self.draw_hist(dc, x, y)

class ClassHistogram(Histogram):
    def refresh(self,dc):
        y = bincount(self.data, self.bins)
        x = self.data
        self.draw_hist(dc, x, y)



